"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const metadata_1 = require("../metadata");
const entity_1 = require("../entity");
const utils_1 = require("../utils");
function Enum(options = {}) {
    return function (target, propertyName) {
        const meta = metadata_1.MetadataStorage.getMetadata(target.constructor.name);
        options = options instanceof Function ? { items: options } : options;
        options.name = propertyName;
        if (options.items instanceof Function) {
            const type = options.items();
            const keys = Object.keys(type);
            options.items = Object.values(type).filter(val => !keys.includes(val));
        }
        meta.properties[propertyName] = Object.assign({ reference: entity_1.ReferenceType.SCALAR, enum: true }, options);
        utils_1.Utils.lookupPathFromDecorator(meta);
    };
}
exports.Enum = Enum;
