"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const metadata_1 = require("../metadata");
const utils_1 = require("../utils");
const entity_1 = require("../entity");
function ManyToMany(entity, mappedBy, options = {}) {
    return function (target, propertyName) {
        options = utils_1.Utils.isObject(entity) ? entity : Object.assign(Object.assign({}, options), { entity, mappedBy });
        options.fixedOrder = options.fixedOrder || !!options.fixedOrderColumn;
        if (!options.owner && !options.inversedBy && !options.mappedBy) {
            options.owner = true;
        }
        if (options.owner) {
            utils_1.Utils.renameKey(options, 'mappedBy', 'inversedBy');
        }
        const meta = metadata_1.MetadataStorage.getMetadata(target.constructor.name);
        utils_1.Utils.lookupPathFromDecorator(meta);
        const property = { name: propertyName, reference: entity_1.ReferenceType.MANY_TO_MANY, owner: !!options.inversedBy, cascade: [entity_1.Cascade.PERSIST, entity_1.Cascade.MERGE] };
        meta.properties[propertyName] = Object.assign(property, options);
    };
}
exports.ManyToMany = ManyToMany;
