"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const metadata_1 = require("../metadata");
const utils_1 = require("../utils");
const entity_1 = require("../entity");
function ManyToOne(entity = {}, options = {}) {
    return function (target, propertyName) {
        options = utils_1.Utils.isObject(entity) ? entity : Object.assign(Object.assign({}, options), { entity });
        if (options.fk) {
            throw new Error(`@ManyToOne({ fk })' is deprecated, use 'inversedBy' instead in '${target.constructor.name}.${propertyName}'`);
        }
        const meta = metadata_1.MetadataStorage.getMetadata(target.constructor.name);
        utils_1.Utils.lookupPathFromDecorator(meta);
        const property = { name: propertyName, reference: entity_1.ReferenceType.MANY_TO_ONE, cascade: [entity_1.Cascade.PERSIST, entity_1.Cascade.MERGE] };
        const prop = Object.assign(property, options);
        utils_1.Utils.defaultValue(prop, 'nullable', prop.cascade.includes(entity_1.Cascade.REMOVE) || prop.cascade.includes(entity_1.Cascade.ALL));
        meta.properties[propertyName] = prop;
    };
}
exports.ManyToOne = ManyToOne;
