"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const metadata_1 = require("../metadata");
const entity_1 = require("../entity");
const utils_1 = require("../utils");
function PrimaryKey(options = {}) {
    return function (target, propertyName) {
        const meta = metadata_1.MetadataStorage.getMetadata(target.constructor.name);
        options.name = propertyName;
        meta.primaryKey = propertyName;
        meta.properties[propertyName] = Object.assign({ reference: entity_1.ReferenceType.SCALAR, primary: true }, options);
        utils_1.Utils.lookupPathFromDecorator(meta);
    };
}
exports.PrimaryKey = PrimaryKey;
