import { Cascade } from '../entity';
import { EntityName, AnyEntity } from '../typings';
export declare function Property(options?: PropertyOptions): Function;
export declare type PropertyOptions = {
    name?: string;
    fieldName?: string;
    columnType?: string;
    type?: any;
    length?: any;
    onUpdate?: () => any;
    default?: any;
    unique?: boolean;
    nullable?: boolean;
    unsigned?: boolean;
    persist?: boolean;
    hidden?: boolean;
    version?: boolean;
};
export interface ReferenceOptions<T extends AnyEntity<T>> extends PropertyOptions {
    entity?: string | (() => EntityName<T>);
    cascade?: Cascade[];
    eager?: boolean;
}
