import { EntityManager } from '../EntityManager';
import { EntityMetadata, AnyEntity, WrappedEntity } from '../typings';
import { LockMode } from '../unit-of-work';
export declare class EntityHelper {
    static init<T extends AnyEntity<T>>(entity: T, populated?: boolean, lockMode?: LockMode): Promise<T>;
    static decorate<T extends AnyEntity<T>>(meta: EntityMetadata<T>, em: EntityManager): void;
    /**
     * defines magic id property getter/setter if PK property is `_id` and there is no `id` property defined
     */
    private static defineIdProperty;
    private static defineBaseProperties;
    private static defineBaseHelperMethods;
    private static definePrimaryKeyProperties;
}
/**
 * wraps entity type with AnyEntity internal properties and helpers like init/isInitialized/populated/toJSON
 */
export declare function wrap<T>(entity: T): T & WrappedEntity<T, keyof T>;
