import { MetadataStorage } from '../metadata';
import { EntityData, AnyEntity } from '../typings';
import { ChangeSet } from './ChangeSet';
import { EntityIdentifier, EntityValidator } from '../entity';
import { Platform } from '../platforms';
export declare class ChangeSetComputer {
    private readonly validator;
    private readonly originalEntityData;
    private readonly identifierMap;
    private readonly metadata;
    private readonly platform;
    constructor(validator: EntityValidator, originalEntityData: Record<string, EntityData<AnyEntity>>, identifierMap: Record<string, EntityIdentifier>, metadata: MetadataStorage, platform: Platform);
    computeChangeSet<T extends AnyEntity<T>>(entity: T): ChangeSet<T> | null;
    private computePayload;
    private processReference;
    private processManyToOne;
    private processManyToMany;
    private processOneToOne;
}
